> ## Documentation Index
> Fetch the complete documentation index at: https://docs.herondata.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Add and remove sender matchers across many funder exclusion rules

> A rule left with no senders is deleted.



## OpenAPI

````yaml https://app.herondata.io/swagger patch /api/funder_exclusion_rules/bulk/
openapi: 3.0.0
info:
  contact:
    email: support@herondata.io
    name: Support
  title: Heron Data API
  version: '2021-07-19'
servers:
  - description: Production
    url: https://app.herondata.io
security:
  - ApiKeyAuth:
      - key_XXX
externalDocs:
  description: Read Tutorial
  url: https://docs.herondata.io/
paths:
  /api/funder_exclusion_rules/bulk/:
    patch:
      summary: Add and remove sender matchers across many funder exclusion rules
      description: A rule left with no senders is deleted.
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BulkFunderExclusionRuleUpdateSchema'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/BulkFunderExclusionRuleResultSchema'
                type: array
          description: >-
            Outcome per deduplicated funder, in request order; key by
            funder_heron_id, not index
        '400':
          description: Nothing to add or remove
        '404':
          description: Broker customer, funder, or funder exclusion rule not found
        '422':
          description: Invalid request body
      security:
        - ApiKeyAuth: []
components:
  schemas:
    BulkFunderExclusionRuleUpdateSchema:
      additionalProperties: false
      properties:
        add:
          $ref: '#/components/schemas/FunderExclusionSenderIdentitySchema'
        funder_heron_ids:
          items:
            type: string
          maxItems: 200
          minItems: 1
          type: array
        remove:
          $ref: '#/components/schemas/FunderExclusionSenderIdentitySchema'
      required:
        - funder_heron_ids
      type: object
    BulkFunderExclusionRuleResultSchema:
      properties:
        action:
          enum:
            - created
            - updated
            - unchanged
            - deleted
          readOnly: true
        funder_heron_id:
          readOnly: true
          type: string
      type: object
    FunderExclusionSenderIdentitySchema:
      additionalProperties: false
      properties:
        sender_domains:
          items:
            pattern: >-
              ^(?:[A-Za-z0-9](?:[A-Za-z0-9-]{0,61}[A-Za-z0-9])?\.)+[A-Za-z]{2,63}$
            type: string
          type: array
        sender_emails:
          items:
            format: email
            type: string
          type: array
        sender_names:
          items:
            type: string
          type: array
      type: object
  securitySchemes:
    ApiKeyAuth:
      in: header
      name: x-api-key
      type: apiKey

````